Smart Proxy - Bug #13575

Don't fail due to missing PXEClient DHCP opt on 2008R2
02/05/2016 06:00 AM - Guido Giinther
Assignee: Guido Gunther
Category: DHCP
Target version: 1.12.1
Difficulty: Fixed in Releases:
Pull request: https://github.com/theforeman/smart-pro
xy/pull/372
Description

Due to #2870 the dhcp_native_ms provider always tries to set the
PXEClIient opt to empty. However this does not exist in all DHCP servers
(tested on 2008R2) and in this case we currently fail with:

INFO —- : Added DHCP reservation for foo.example.com(10.0.2.20 / 52:54:00:84:64:03)
DEBUG —-- : key: "PXEClient"
DEBUG —-- : executing: c:\windows\system32\cmd.exe /c c:\Windows\System32\netsh.exe
e—dhep——server—127-0-06-% ope—10-0-0-0——set—reservedeptionvatue106-0-2-2060—String 11

——INFO6— : Vendor class not found
ERROR ——- : Netsh failed:

Changed the current scope context to 10.0.0.0 scope.
The specified option does not exist.

ERROR -- : Unknown error while processing ''
DEBUG —-- : Unknown error while processing '' (Proxy::DHCP::Error)
C:/Users/Administrator/Downloads/smart-proxy/modules/dhcp_native_ms/dhcp_native_ms_main.rb:246
:in “rescue in report'
C:/Users/Administrator/Downloads/smart-proxy/modules/dhcp_native_ms/dhcp_native_ms_main.rb:223
:in “report'
C:/Users/Administrator/Downloads/smart-proxy/modules/dhcp_native_ms/dhcp_native_ms_main.rb:218
:in “execute'
C:/Users/Administrator/Downloads/smart-proxy/modules/dhcp_native_ms/dhcp_native_ms_main.rb:59:
in “block in add_record’
C:/Users/Administrator/Downloads/smart-proxy/modules/dhcp_native_ms/dhcp_native_ms_main.rb:46:
in “each'
C:/Users/Administrator/Downloads/smart—-proxy/modules/dhcp_native_ms/dhcp_native_ms_main.rb:46:
in “add_record'
C:/Users/Administrator/Downloads/smart-proxy/modules/dhcp/dhcp_api.rb:97:in “block in &lt;clas
s:DhcpApi&gt; '
C:/Users/Administrator/Downloads/smart-proxy/vendor/ruby/2.1.0/gems/sinatra-1.4.7/1ib/sinatra/
base.rb:1611:in “call'

so ignore errors to set that option.

Related issues:

Related to Smart Proxy - Bug #5995: Windows AD DHCP reservation creation fail... Duplicate 05/30/2014
Related to Smart Proxy - Bug #15789: In MS DHCP provider general/Vendor optio... Resolved 07/22/2016
Related to Smart Proxy - Bug #15791: Intermittent DHCPServerMicrosoftTest fai... Closed 07/22/2016
Related to Smart Proxy - Bug #16056: Non-english locale casuses "Vendor Class... Resolved 08/11/2016
https://projects.theforeman.org/issues/2870

fixes #13575 - Don't fail on missing PXEClient dhcp opt

Due to #2870 the dhcp_native_ms provider always tries to set the
PXECIient opt to empty. However this does not exist in all DHCP servers
(tested on 2008R2) and in this case we currently fail with:

INFO -- : Added DHCP reservation for foo.example.com(10.0.2.20 / 52:54:00:84:64:03)
DEBUG -- : key: "PXEClient"
DEBUG -- : executing: c:\windows\system32\cmd.exe /c c:\Windows\System32\netsh.exe
Al 127 al al | 10 al al al 4 =i e 1 10 02 20 al [aFS 3 nw
diep ryer—127-0-0-1 pe—10-0-0= t—r rvedoptionvatue—10-0-2= 60—String
—INF6— : Vendor class not found
ERROR —-- : Netsh failed:

Changed the current scope context to 10.0.0.0 scope.
The specified option does not exist.

ERROR —-- : Unknown error while processing ''
DEBUG -- : Unknown error while processing '' (Proxy::DHCP::Error)

C:/Users/Administrator/Downloads/smart-proxy/modules/dhcp_native_ms/dhcp_native_ms_main.

in report'

C:/Users/Administrator/Downloads/smart-proxy/modules/dhcp_native_ms/dhcp_native_ms_main.
C:/Users/Administrator/Downloads/smart-proxy/modules/dhcp_native_ms/dhcp_native_ms_main.

C:/Users/Administrator/Downloads/smart-proxy/modules/dhcp_native_ms/dhcp_native_ms_main.

add_record'

C:/Users/Administrator/Downloads/smart-proxy/modules/dhcp_native_ms/dhcp_native_ms_main.

rb:

rb:
rb:

rb:

rb:

246:in " rescue

223:in " report'
218:in "~ execute

59:in “block in

46:in “each'

C:/Users/Administrator/Downloads/smart-proxy/modules/dhcp_native_ms/dhcp_native_ms_main.rb:46:in ~add_reco
rd'

C:/Users/Administrator/Downloads/smart-proxy/modules/dhcp/dhcp_api.rb:97:in ‘block in &lt;class:DhcpApis&gt
g o

C:/Users/Administrator/Downloads/smart-proxy/vendor/ruby/2.1.0/gems/sinatra-1.4.7/1ib/sinatra/base.rb:1611
:in “call"

so ignore errors to set that option.
Also add a test that verifies adding dhcp records and one that checks

that we still correctly raise errors when we fail to set dhcp options
(execpt for PXEClient).

History

#1 - 02/15/2016 01:13 PM - The Foreman Bot
- Status changed from New to Ready For Testing

- Assignee set to Guido Glinther

#2 - 02/29/2016 09:44 AM - Anonymous
- Related to Bug #5995: Windows AD DHCP reservation creation fails with "The specified option does not exist" added

#3 - 07/21/2016 06:02 AM - Guido Glinther
- Status changed from Ready For Testing to Closed
- % Done changed from 0 to 100

Applied in changeset e5aa23440a5042f5697788e354c62a5be826ab30.

#4 - 07/21/2016 06:06 AM - Dominic Cleal

- translation missing: en.field_release set to 161

#5 - 07/22/2016 08:08 AM - Anonymous
- Related to Bug #15789: In MS DHCP provider general/Vendor options must exist before assigning values to them added

#6 - 07/22/2016 09:56 AM - Anonymous
- Related to Bug #15791: Intermittent DHCPServerMicrosoftTest failures on ruby 1.8.7 added

#7 - 08/11/2016 04:19 AM - Dominic Cleal

- Has duplicate Bug #16056: Non-english locale casuses "Vendor Class not found" errors when using windows dhcp provider added
#8 - 08/11/2016 05:22 AM - Dominic Cleal

- Has duplicate deleted (Bug #16056: Non-english locale casuses "Vendor Class not found" errors when using windows dhcp provider)

#9 - 08/11/2016 05:22 AM - Dominic Cleal

- Related to Bug #16056: Non-english locale casuses "Vendor Class not found" errors when using windows dhcp provider added
